#include "http_configuration.h"
#include "utils.h"
#include "bgi_lib.h"
#include <ctype.h>

extern int handle_http(int sock, http_configuration* config) {
  char buf[8192];
  char* cp = buf;

  int n = read(sock,buf,8192);
  if(n <= 0 ) {
    return 0;
  }

  char* end = buf+n;
  int c;

  char* method = new char[10];
  char* method_ptr = method;
  char* method_end = method+10;
  while((c =next_char(buf,8192,cp,end,sock)) >= 0) {
    if(c == ' ') {
      break;
    }
    push_char(method,method_end,method_ptr,c);
  }
  if(c <0) {
    delete method;
    return -1;
  }
	   
  push_char(method,method_end,method_ptr,0);

  char* url = new char[40];
  char* url_ptr = url;
  char* url_end = url+40;
  while((c = next_char(buf,8192,cp,end,sock)) >= 0) {
    if(c == ' ' || c == '\n' || c == '\r') {
      break;
    }
    if(c == '%') {
      int hex;
      c = 0;
      hex = next_char(buf,8192,cp,end,sock);
      
      if(isxdigit(hex)) {
	if(isdigit(hex)) {
	  c = hex - '0';
	} else if (islower(hex)) {
	  c = (hex - 'a') + 10;
	} else {
	  c = (hex - 'A') + 10;
	}
      } else {
	c = -1;
	break;
      }
      c *= 16;
      hex = next_char(buf,8192,cp,end,sock);
      if(isxdigit(hex)) {
	if(isdigit(hex)) {
	  c += hex - '0';
	} else if (islower(hex)) {
	  c += (hex - 'a') + 10;
	} else {
	  c += (hex - 'A') + 10;
	}
      } else {
	c = -1;
	break;
      }
    }
    push_char(url,url_end,url_ptr,c);
  }
  if(c < 0) {
    delete method;
    delete url;
    return -1;
  }
  push_char(url,url_end,url_ptr,0);
  char* version = new char[8];
  char* version_end = version+8;
  char* version_ptr = version;
  int version_number=0;
  if(c == ' ') {
    while((c = next_char(buf,8192,cp,end,sock)) >= 0) {
      if(c == '\r' || c == '\n' || c < 0) {
	break;
      }
      push_char(version,version_end,version_ptr,c);
    }
    if(c <0) {
      delete version;
      delete url;
      delete method;
      return -1;
    } else {
      push_char(version,version_end,version_ptr,0);
    }
  } else {
    delete version;
    version =0;
  }
  if(c == '\r') {
    c = next_char(buf,8192,cp,end,sock);
  }
  if(c != '\n') {
    delete version;
    delete url;
    delete method;
    return -1;
  }
  sock_buf* sb = new sock_buf;
  sb->buffer = buf;
  sb->buf_size = 8192;
  sb->end_of_buffer = end;
  sb->current_ptr = cp;
  sb->sock = sock;
  
  int result = config->dispatcher->handle(method,url,version,sb);
  if(result && result != 200) {
    http_error(sb,result,version);
  }
  delete sb;
  delete method;
  delete url;
  delete version;
  return 0;
}
