#include "http.h"
#include "utils.h"
#include "bgi_lib.h"
#include <ctype.h>
#include <signal.h>
#include <sys/socket.h>

extern int handle_http(int sock, http_configuration* config);
http_configuration* current_configuration; int debug=0;


class http_handler : public thread_class {
  int sock;
  http_configuration* config;
public:
  http_handler(http_configuration*c, inet_connect_info* args) {
    sock = args->accept_socket;
/*    struct linger lin;
    int lin_size=sizeof(lin);
    lin.l_onoff=1;
    lin.l_linger=30;
    if(setsockopt(sock,SOL_SOCKET,SO_LINGER,(char*)&lin,lin_size)) {
      perror("set linger:");
    }
    */
    config = c;
  }
  ~http_handler() {close(sock);}
  //~http_handler() {shutdown(sock,2);close(sock);}
  void* run() {
    thr_setprio(thr_self(),0);
    handle_http(sock,config);
    return 0;
  }
};

void* http_daemon::get_connection() {
  void* tmp;
  sigrelse(SIGHUP);
  tmp = inet_daemon::get_connection();
  sighold(SIGHUP);
  return tmp;
}

static void restart_handler(int sig,siginfo* info, void* foo) {

  int listen_sock = listen_thread->listen_sock;
  
  if(thr_self() != listen_id) {
    fprintf(stderr,"error - restart delivered to wrong thread\n");
    thr_kill(listen_id,sig);
    return;
  }
  if(fork1()) {
    close(listen_sock);
    thr_exit(0);
  } else {
    if(listen_sock != 0) {
      close(0);
      dup(listen_sock);
    }
    printf("restarting\n");
    extern char** glob_argv;
    extern int glob_argc;
    extern int secret_socket;

    char** new_argv = new char*[glob_argc+2];
    int i;
    for(i=0;i<glob_argc;i++) {
      new_argv[i]=glob_argv[i];
    }
    if(secret_socket <0) {
      new_argv[i++] = "-S";
    }
    new_argv[i++] = 0;
    if(execv(new_argv[0],new_argv)) {
      perror("execv:");
      exit(1);
    }
  }
}
    
  
int http_daemon::setup() {
  int tmp;
  tmp = inet_daemon::setup();
  thr_setprio(thr_self(),100);
  struct sigaction sa;
  sa.sa_sigaction = restart_handler;
  sa.sa_flags = SA_SIGINFO | SA_RESTART;
  sigemptyset(&sa.sa_mask);
  sighold(SIGHUP);
  sigaction(SIGHUP,&sa,0);
  
  return tmp;
}
  
thread_class* http_daemon::new_child(void* args) {
  return new http_handler(config,(inet_connect_info*)args);
}

