#ifndef HTTP_CONFIGURATION_H
#define HTTP_CONFIGURATION_H

#include "bgi.h"
#include "hash_table.h"
#include "log.h"

class http_configuration {
 public:

  char* root;
  int port;
  url_dispatcher* dispatcher;
  hash_table<char>* ext_to_mime_table;
  logger* message_logger;

  http_configuration() {
    port = 80; root = 0;dispatcher = new url_dispatcher; 
    ext_to_mime_table = new hash_table<char>(31);
    message_logger = new logger;
  }
  int load_configuration(char* fstab, char* mime_tab,char* root, char* logtab,
			 int port);
  ~http_configuration() {
    delete root; delete dispatcher; delete ext_to_mime_table; delete 
      message_logger;  }
};

extern http_configuration* current_configuration;
extern int debug;
#endif
