#include "bgi_lib.h"
#include <netdb.h>
#include <stdio.h>


extern "C" {
  void* test_open(char* args);
  int test_close(void* cookie);
  int  test_message  (void* cookie, char* method, char* url,
		      char* ident, char* auth_user, int status,
		      time_t date,struct sockaddr* host,
		      int host_size);
}

struct test_cookie {
  FILE* log_file;
  test_cookie(char* filename) {
    log_file = fopen(filename,"a+");
  }
  ~test_cookie() {
    if(log_file) 
      fclose(log_file);
  }
};


void* test_open(char* args) {
  printf("opening test-log on %s\n",args);
  test_cookie* cookie = new test_cookie(args);
  if(cookie->log_file == 0) {
    delete cookie;
    return 0;
  } else {
    return cookie;
  }
}

int test_close(void* cookie) {

  test_cookie* tc = (test_cookie*)cookie;
  delete tc;
  return 0;
}


int  test_message  (void* cookie, char* method, char* url,
		    char* ident, char* auth_user, int status,
		    time_t date,struct sockaddr* host,
		    int host_size) {
  test_cookie* tc = (test_cookie*)cookie;
  sockaddr_in* sin = (sockaddr_in*)host;

  char time_buf[40];
  
  in_addr* addr = &(sin->sin_addr);
  char* hostname;
  char buf[20];
  hostent* he = 0;
//  he = gethostbyaddr((char*)addr,sizeof(in_addr),AF_INET);
  if(he) {
    hostname = he->h_name;
  } else {
    sprintf(buf,"%d.%d.%d.%d", addr->S_un.S_un_b.s_b1,
	    addr->S_un.S_un_b.s_b2, addr->S_un.S_un_b.s_b3,
	    addr->S_un.S_un_b.s_b4);
    hostname = buf;
  }
  fprintf(tc->log_file,"[%s] %s %s %s",hostname,method,url,ctime_r(&date,time_buf,40));
  return 0;
}
