#ifndef MT_CACHE
#define MT_CACHE
#include "mt_hashtable.h"

template <class C>  
class cache_object : public shared_object {
 public:
  C* data;
  char* key;
  int size;
  shared_counter use_count;
  cache_object(char* k, C* v, int s) : shared_object() {
    key = k; data = v ; size = s ; use_count = 1;
    lock();
  }
  ~cache_object() {
    delete key; delete data;
  }
 };

template <class C>
class shared_cache  {
  mt_hashtable<C>* the_table;
 public:
  shared_cache(int n) { the_table = new mt_hashtable<C>(n);}
  cache_object* find_object_by_name(char* key);
  int release_object(cache_object* obj);
};

#endif 
