// $Id: mt_hashtable.h,v 1.1 1994/06/24 22:05:34 ses Exp ses $
#ifndef MT_HASH_TABLE_H
#define MT_HASH_TABLE_H

#include "hash.h"
#include "mt_list.h"

#include <string.h>
#include <memory.h>

template<class C> 
class mt_hash_table {  
 protected:
  mt_dlist<C>* buckets;
  int num_buckets;
  
  public:
    mt_hash_table(int nb) {
      num_buckets = nb;
      buckets = new mt_dlist<C>[num_buckets];
    }
    ~mt_hash_table() {
      delete buckets;
    }
  void map(void (*f)(char* k, C* i)) {
    int i;
    for(i=0;i<num_buckets;i++) {
      buckets[i].map(f);
    }
  }
  C* find(char* key,int nolock=0) {
    int hash_code = hash(key) % num_buckets;
    return  buckets[i].find(key,nolock);
  }
  int add(char* key, C* value,int nolock=0) {
    int hash_code = hash(key) % num_buckets;
    return buckets[hash_code].add(key,value,nolock);
  }
  int lock(char* key) {
    int hash_code = hash(key) % num_buckets;
    return buckets[hash_code].lock();
  }
  int unlock(char* key) {
    int hash_code = hash(key) % num_buckets;
    return buckets[hash_code].unlock();
  }
  dlist<C>* find_list(char* key) {
    int hash_code = hash(key) % num_buckets;
    return buckets+hash_code;
  }
};
#endif

