#ifndef UTILS_H
#define UTILS_H
#ifdef HAVE_CONFIG_H
#include "mt_config.h"
#endif

#ifdef HAVE_SYSENT_H
#include <sysent.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <memory.h>

#include <stdio.h>

char* getline(FILE* in,int* line_no = 0);

static inline int match_one(char c, char* pattern) {
  while(*pattern) {
    if(c == *pattern)
      return 1;
    pattern++;
  }
  return 0;
}


static inline int match_all(char* cp, char* pattern) {
  while(*cp && *pattern ) {
    if(*cp != *pattern)
      return 0;
    cp++;
    pattern++;
  }
  return 1;
}

static inline void push_string(char**& array, int& size, 
			       int& cur,char* string) {
  if(cur == size -2) {
    char** tmp = new char*[size+5];
    int i;
    for(i=0;i<cur;i++) {
      tmp[i] = array[i];
    }
    delete array;
    array = tmp;
    size += 5;
  }
  array[cur++] = string;
  array[cur] = 0;
}

static inline void push_char(char*& string, char*& end, char*&cur,
			     char c) {

  if(cur == end - 2) {
    int size = cur-string;
    int new_size = size + 20;
    char* tmp = new char[new_size];
    memcpy(tmp,string,size);
    delete string;
    string = tmp;
    end = string + new_size;
    cur = string + size;
  }
  *cur++ = c;
}


static inline int next_char(unsigned char* buf, int size,
			    unsigned char*& cp, unsigned char*& end,
			    int fd) {
  if(cp == end) {
    int n = read(fd, buf, size);
    if(n <=0) {
      cp =buf;
      end = buf;
      return -1;
    } else {
      cp = buf;
      end = cp+n;
    }
  }
  return *cp++;
}
    

#endif
