#include "utils.h"
#ifdef HAVE_SYSENT_H
#include <sysent.h>
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#include <memory.h>


char* getline(FILE* in,int* line_no) {
  char* tmp = new char[80];
  char* cp = tmp;
  char* end = tmp+80;

  int c;

  // STATE = START_HERE
  c = getc(in);
  
  // STATE = FIND_START
 find_start:
  if(c == EOF) {
    goto done;
  }
  if(c == '\n') {
    if(line_no) (*line_no)++;
    c = getc(in);
    goto find_start;
  }
  if(c == '#') {
    while(1) {
      c = getc(in);
      if(c == EOF || c == '\n')
	goto find_start;
    }
  }
  *cp++ = c;
  c = getc(in);
  
  /// STATE = GET_LINE
 get_line:
  if(c == '\n') {
    goto hit_eol;
  }
  if(c == EOF) {
    goto done;
  }
  push_char(tmp,end,cp,c);
  c = getc(in);
  goto get_line;

  /// STATE = HIT_EOL
 hit_eol:
  if(line_no) (*line_no)++;
  c = getc(in);
  if(c == '\t' || c == ' ') {
    goto get_line;
  }
  ungetc(c,in);
  goto done;

  // STATE = DONE
 done:
  if (cp == tmp) {
    delete tmp;
    return 0;
  } else {
    *cp=0;
    return tmp;
  }
}
  

      
    
    

  

  
  
