#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sysent.h>

#include "hash.h"
#include "hash_table.h"

template <class C>
class list {
  C* _car;
  list<C>* _cdr;
public:
  list(C* a, list<C>* b) {_car = a ; _cdr = b;}
  ~list() {
    delete _car;
    delete _cdr;
  }
  C* car() { return _car;}
  list<C>* cdr() {return _cdr;}
};

  
class element {
public:
  typedef enum {zero_or_one,one,zero_or_many,one_or_many} repeat_enum;
  typedef enum {PCDATA,CDATA,SEQUENCE,OR,NAME} node_type_enum;
  repeat_enum repeat;
  node_type_enum type;

  union {
    list<element>* model;
    char* name;
  } u;
  
  element(repeat_enum r=one) {
    repeat = r;
    type = PCDATA;
  }
  element(char* n, repeat_enum r = one) {
    repeat =r;
    type = NAME;
    u.name = strdup(n);
  }
  element(node_type_enum t,list<element>* l, repeat_enum r = one) {
    repeat =r;
    type = t;
    u.model = l;
  }
};
    
struct element_type {
  char* name;
  int omit_flags;
  element* thing;
  list<char*>* attributes;
};

struct attrib {
  char* label;
  char* value;
};

struct parse_tree {
  enum {LIST,SINGLE} what;
  list<attrib>* attributes;
  union {
    list<parse_tree>* a_list;
    char* single;
  } u;
};
