#include <sys/types.h>
#include <thread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
  
int value=0;
mutex_t value_lock;

void* writer(void* data) {
  int limit = *(int*)data;
  while(1) {
    mutex_lock(&value_lock);
    value++;
    if(value > limit) {
      printf("value passed limit of %d (%d)\n",limit,value);
      exit(0);
    }
    mutex_unlock(&value_lock);
//    sleep(1);
  }
  return 0;
}

main(int argc, char** argv) {

  if(argc <2) {
    printf("usage: thread <limit> [ num writers]\n");
    exit(1);
  }
  int limit = atoi(argv[1]);
  int num_writers = 1;
  if(argc >2) {
    num_writers = atoi(argv[2]);
  }
  mutex_init(&value_lock,USYNC_THREAD,0);
  int n;
  for(n=0;n<num_writers;n++) {
    thr_create(NULL,0,writer,&limit,THR_BOUND,NULL);
  }
  pause();
}
  
